#!/usr/bin/perl -w
#
# first2list
# Takes a parsed PFS:First Choice file
#  (parsed with first2html) and a command line
#  argument of the fields to include.

# Argument is a quoted string, of field numbers,
#  separated by commas, of fields.

# Examples:
# "1,3,4" = field 1, 3 ,4 (not 2)
# "-4,6"  = field 1,2,3,4,6
# etc
	
# command line argument hiding
my $f ;
if ( $#ARGV < 0 ) {
	$f = "-" ;
} else {
	$f = join(" ",@ARGV) ;
}
@ARGV = () ;


# Copy until <TABLE> line, inclusive
while (<>) {
	last if /<TABLE/i ;
	print ;
}
# print TABLE line, modify TABLE tab if desired
print ;

# Copy until <TH> line - should be next one
while (<>) {
	last if m/<TH/i ;
	print ;
}
# Get Field names
my @fnames = m/<TH.*?>(.*?)<\/TH>/ig ;
my $fnumber =  $#fnames + 1 ;

# parse the command line argument
$f =~ s/\s*-\s*/-/g ;	# remove whitespace around -
$f =~ s/\s*,\s*/,/g ;	# remove whitespace around ,
$f =~ s/\s+/,/g ;	# change whitespace to ,
$f =~ s/^,// ;		# no trailing ,
$f =~ s/,$// ;		# no leading ,
$f =~ s/^$/-/ ;		# if blank, assume - (all)
my @f = map({if (/(\d+)-(\d+)/) {($1..$2)} elsif (/-(\d+)/) {(1..$1)} elsif (/(\d+)-/) {($1..$fnumber)} elsif (/-/) {(1..$fnumber)} else {$_} }  split(",",$f));

# print Field Names
# Can modify field attributes (bgcolor, font, ...) here.
print "<TR>" ;
print map( "<TH>$fnames[$_-1]</TH>" , @f ) ;
print "</TR>\n" ;

# loop through records
my @ofields = @fnames ; # previous fields to substitute for &nbsp
while(<>) {
	last unless (m/<TD/i) ; # break if not a table row
	my @nfields = m/<TD.*?>(.*?)<\/TD>/ig ;
	
	# process the new fields if desired

	# replace &nbsp with previous values
	# this allows sorted lists with blank repeat
	# fields to be repopulated
	my @fields = map {my $o = shift(@ofields) ; if (/\&nbsp\;/) {$o} else {$_} }  @nfields ;

	# Move new fields to old have ready for substitution
	@ofields = @fields ;

	# Do any further processing here
	
	# Now print
# 	Can modify field attributes (bgcolor, font, ...) here.
	print "<TR>" ;
	print map( "<TD>$fields[$_-1]</TD>" , @f ) ;
	print "</TR>\n" ;
}		

# Final copy
print ;
while (<>) {
	print ;
}
